/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[ProgCnet - Boum!]
Auteur: Thaeron
Projet: "serveur" Boum! (bomberman) du concours ProgCnet
Licence: GPL

Copyright (C) 2007 Thaeron

This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the 
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 
USA
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#include "boum.h"

void
ajouter_bombe (void)
{
  tab_bombe =
    (bombe_t **) realloc (tab_bombe, sizeof (bombe_t *) * (struct_map->nb_bombe + 1));
  tab_bombe[struct_map->nb_bombe] = (bombe_t *) malloc (sizeof (bombe_t));
  tab_bombe[struct_map->nb_bombe]->x =
    tab_players[struct_map->current_player]->x;

  tab_bombe[struct_map->nb_bombe]->y =
    tab_players[struct_map->current_player]->y;

  tab_bombe[struct_map->nb_bombe]->puissance =
    tab_players[struct_map->current_player]->puissance;

  tab_bombe[struct_map->nb_bombe]->player =
    tab_players[struct_map->current_player];

  tab_bombe[struct_map->nb_bombe]->tours = NB_TOURS_BOMBE;

  tab_bombe[struct_map->nb_bombe]->a_explose = 0;

  struct_map->nb_bombe++;
}

bombe_t *
get_bombe (int x, int y)
{
  int i;
  for (i = 0; i < struct_map->nb_bombe; i++)
    if (x == tab_bombe[i]->x && y == tab_bombe[i]->y)
      return (tab_bombe[i]);
  return (NULL);
}

void
clean_bombe_tab (void)
{
  int i, nb = 0;
  bombe_t **tmp = NULL;
 /* printf ("il y a %d bombes\n", struct_map->nb_bombe);*/
  
  for (i = 0; i < struct_map->nb_bombe; i++)
    {
      if (!tab_bombe[i]->tours)
	{
	  if (!tab_bombe[i]->a_explose)
	    printf ("probleme : une bombe a expir mais n'a pas explos !\n");
	  /*virer_bombe (i);*/
	  tab_bombe[i]->player->bombe_dispo++;
	  free (tab_bombe[i]);
	}
      else
      {
	tmp = (bombe_t **) realloc (tmp, sizeof (bombe_t *) * (nb + 1));
	tmp[nb] = tab_bombe[i];
	nb++;
	}
    }
    struct_map->nb_bombe = nb;
    free (tab_bombe);
    tab_bombe = tmp;
    
}

void
free_bombe (bombe_t ** t, int n)
{
  int i;
  for (i = 0; i < n; i++)
    free (t[i]);
  free (t);
}
