/*~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
[ProgCnet - Boum!]
Auteur: Thaeron
Projet: "serveur" Boum! (bomberman) du concours ProgCnet
Licence: GPL

Copyright (C) 2007 Thaeron

This program is free software; you can redistribute it and/or 
modify it under the terms of the GNU General Public License as 
published by the Free Software Foundation; either version 2 of the 
License, or (at your option) any later version.

This program is distributed in the hope that it will be useful, but 
WITHOUT ANY WARRANTY; without even the implied warranty of 
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU 
General Public License for more details.

You should have received a copy of the GNU General Public License 
along with this program; if not, write to the Free Software 
Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 
USA
~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~*/

#include "boum.h"

int
gerer_explosion (int i, int j)
{
  bombe_t *bombe_ptr;
  int tmp;
  
  if (struct_map->map[i][j] == MUR || struct_map->map[i][j] == BRIQUE_FRAGILE || struct_map->map[i][j] == BONUS_FRAGILE)
    return (0);

  if (struct_map->map[i][j] == RIEN || struct_map->map[i][j] == FLAMME)
   {
   	struct_map->map[i][j] = FLAMME;
	return (1);
   }
  
  if (struct_map->map[i][j] == FLAMME_BONUS)
  {
        struct_map->nb_flamme_bonus--;
      	struct_map->map[i][j] = BONUS_FRAGILE;
	return (0);
   }  
   
   if (struct_map->map[i][j] == BOMBE_BONUS)
   {
        struct_map->nb_bombe_bonus--;
      	struct_map->map[i][j] = BONUS_FRAGILE;
	return (0);
   } 
   
   if (struct_map->map[i][j] == MOTION_BONUS)
   {
        struct_map->nb_motion_bonus--;
      	struct_map->map[i][j] = BONUS_FRAGILE;
	return (0);
   } 
   
  if (struct_map->map[i][j] >= JOUEUR && struct_map->map[i][j] < RIEN)
    {
   /*   printf ("le joueur %d est mort\n", struct_map->map[i][j] - JOUEUR);*/
      tab_players[struct_map->map[i][j] - JOUEUR]->status = MORT;
      struct_map->nb_joueur_lice--;
      struct_map->map[i][j] = FLAMME;
      return (1);
    }
  
  if (struct_map->map[i][j] >= BOMBE_JOUEUR)
  {
    tmp = struct_map->map[i][j] - BOMBE_JOUEUR + JOUEUR;
  /*  printf ("le joueur %d est mort\n", tmp);*/
    tab_players[tmp]->status = MORT;
    struct_map->nb_joueur_lice--;
    struct_map->map[i][j] = BOMBE;
  } /* pas de return car il faut qu'on entre dans le if suivant */
    
  
  if (struct_map->map[i][j] == BOMBE)
  {
    bombe_ptr = get_bombe (i, j);
    if (!bombe_ptr)
    	printf ("je pense qu'il ya un petit probleme : une bombe est sur la map mais pas dans le tableau\n");
    else
    {
	bombe_ptr->tours = 0;
	/*if (!bombe_ptr->a_explose)
	for (tmp = 0; tmp < struct_map->nb_bombe; tmp++)
		if (tab_bombe[tmp] == bombe_ptr)
		{
			printf ("la bombe %d est touche par une explosion\n", tmp);
			break;
		}*/
     }
    struct_map->map[i][j] = FLAMME;
    return (1);
  }
	
  
  if (struct_map->map[i][j] == BRIQUE)
    {
      struct_map->map[i][j] = BRIQUE_FRAGILE;
      return (0);
    }
  return (1);
}


void
ajouter_explosion (int k)
{
  int i, pu;
  int x, y;
  pu = tab_bombe[k]->puissance / 2;
  x = tab_bombe[k]->x;
  y = tab_bombe[k]->y;
  
  /*virer_bombe (k);*/
  tab_bombe[k]->a_explose = 1;

      gerer_explosion (x, y);

  /*if (struct_map->map[x][y] >= BOMBE_JOUEUR)
    {
      struct_map->map[x][y] = struct_map->map[x][y] - BOMBE_JOUEUR + JOUEUR;
      gerer_explosion (x, y);
    }
  else
    struct_map->map[x][y] = FLAMME;/*/

  for (i = x; i < x + pu; i++)
    if (!gerer_explosion (i, y))
      break;

  for (i = x; i > x - pu; i--)
    if (!gerer_explosion (i, y))
      break;

  for (i = y; i < y + pu; i++)
    if (!gerer_explosion (x, i))
      break;

  for (i = y; i > y - pu; i--)
    if (!gerer_explosion (x, i))
      break;
}

void
virer_explosion (void)
{
  int i, j;
  for (i = 0; i < struct_map->hauteur; i++)
    for (j = 0; j < struct_map->longueur; j++)
      if (struct_map->map[i][j] == FLAMME)
	struct_map->map[i][j] = RIEN;
}
